unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls,jpeg, ExtDlgs, ComCtrls, Buttons, Menus,
  FileCtrl,Thumbs,ShellCtrls,
  //fonctions pratiques de traitement des cahines de caracteres
  //auteur Michel Bardou http://www.phidels.com
  FonctionsChaine,
  // composant ScruteDossier est un composant permettant d'explorer une
  //arborescence de fichiers dans un disque.
  // auteur Michel Bardou
  Scrute
  ;


type
  TForm1 = class(TForm)
    GridSource: TStringGrid;
    PreviewCheck: TCheckBox;
    PreviewZone: TGroupBox;
    PreviewImage: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PopupMenu1: TPopupMenu;
    Ajouerimages1: TMenuItem;
    AjouterRprtoire1: TMenuItem;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Shape1: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    CheckBox5: TCheckBox;
    Edit5: TEdit;
    UpDown3: TUpDown;
    CheckBox4: TCheckBox;
    Edit3: TEdit;
    ColorDialog1: TColorDialog;
    ScruteSource: TScruteDossier;
    OpenPictureDialog1: TOpenPictureDialog;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    Button2: TButton;
    procedure FormActivate(Sender: TObject);
    procedure GridSourceClick(Sender: TObject);
    procedure PreviewCheckClick(Sender: TObject);
    procedure ScruteSourceFichier(Sender: TObject; Nom: String);
    procedure BitBtn1Click(Sender: TObject);
    procedure Ajouerimages1Click(Sender: TObject);
    procedure AjouterRprtoire1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Shape1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);





  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  NbImage:integer;



implementation



{$R *.dfm}




function TailleFichier(fichier: string): double;
{=================================================================}
{ fonction renvoyant la taille du fichier  en Koctets             }
{=================================================================}
var SearchRec:TSearchRec;
    Resultat:integer;
begin
  Result:=0;
  Resultat:=FindFirst(fichier, FaAnyFile, SearchRec);
  if Resultat=0 then Result:=SearchRec.Size/1024;
  FindClose(SearchRec);
end;



procedure TForm1.FormActivate(Sender: TObject);
begin
  //initialisation
  GridSource.Cells[0,0]:='Nom d''image';
  GridSource.Cells[1,0]:='Dimension';
  GridSource.Cells[2,0]:='Taille';
  NbImage:=0;
  edit4.Text:= ExtractFilePath(Application.ExeName);
  edit6.Text:= 'Gallerie';

end;

{=================================================================}
{ Gestion de l'aperu  des images                                 }
{=================================================================}

//Afficher l'appercu
procedure TForm1.GridSourceClick(Sender: TObject);
begin
  if (GridSource.Cells[3,GridSource.row]<>'') and PreviewCheck.Checked then
    begin
      PreviewImage.Picture.LoadFromFile(GridSource.Cells[3,GridSource.row]);
      PreviewImage.show;
    end
  else PreviewImage.Hide;


end;
//Cacher l'appercu
procedure TForm1.PreviewCheckClick(Sender: TObject);
begin
   if PreviewCheck.Checked  then
        PreviewImage.show
   else PreviewImage.Hide;
end;


{=================================================================}
{ Gestion de la liste  des images                                 }
{=================================================================}
//Chargement des images
procedure TForm1.ScruteSourceFichier(Sender: TObject; Nom: String);
var     taille:ImageTaille;
begin
        NbImage:=NbImage+1;
        taille:=getImageTaille(Nom);
        GridSource.Cells[0,NbImage]:=ExtractFilename(Nom);
        GridSource.Cells[1,NbImage]:=inttostr(taille.width)+' x '
                                         +inttostr(taille.height);
        GridSource.Cells[2,NbImage]:=FormatFloat('0.00',TailleFichier(Nom))+' Ko';
        GridSource.Cells[3,NbImage]:=Nom;
        GridSource.RowCount:=GridSource.RowCount+1;
end;

//Suppresion de la liste
procedure TForm1.BitBtn3Click(Sender: TObject);
var i:integer;
begin
  for i:=0 to NbImage do
    begin
      GridSource.Cells[0,i]:='';
      GridSource.Cells[1,i]:='';
      GridSource.Cells[2,i]:='';
      GridSource.Cells[3,i]:='';
   end;
  GridSource.RowCount:=10;
  GridSource.Cells[0,0]:='Nom d''image';
  GridSource.Cells[1,0]:='Dimension';
  GridSource.Cells[2,0]:='Taille';
  NbImage:=0;
  PreviewImage.hide;
end;

//Suppresion de l'image slectionne
procedure TForm1.BitBtn2Click(Sender: TObject);
var i:integer;
begin
   if (GridSource.Cells[3,GridSource.row]<>'') then
    begin
      for i:=GridSource.row to GridSource.RowCount-1 do
        begin
         GridSource.Cells[0,i]:=GridSource.Cells[0,i+1];
         GridSource.Cells[1,i]:=GridSource.Cells[1,i+1];
         GridSource.Cells[2,i]:=GridSource.Cells[2,i+1];
         GridSource.Cells[3,i]:=GridSource.Cells[3,i+1];
       end;
      NbImage:=NbImage-1;
      if PreviewCheck.Checked and (GridSource.Cells[3,GridSource.row]<>'')then
        begin
          PreviewImage.Picture.LoadFromFile(GridSource.Cells[3,GridSource.row]);
          PreviewImage.show;
        end
      else
          PreviewImage.hide;
    end
end;

//Optiond de mthode d'ajout (Rpertoire ou fichiers)
procedure TForm1.BitBtn1Click(Sender: TObject);
var point:TPoint;
begin
  getCursorPos(point);
  PopupMenu1.Popup(point.X,point.Y);
end;

//Ajout d'une ou des images
procedure TForm1.Ajouerimages1Click(Sender: TObject);
var i:integer;
    taille:ImageTaille;
begin

 if OpenPictureDialog1.Execute then
   begin
     with OpenPictureDialog1.Files do
      for i := 0 to Count - 1 do
      begin
        NbImage:=NbImage+1;
        taille:=getImageTaille(Strings[i]);
        GridSource.Cells[0,NbImage]:=ExtractFilename(Strings[i]);
        GridSource.Cells[1,NbImage]:=inttostr(taille.width)+' x '
                               +inttostr(taille.height);
        GridSource.Cells[2,NbImage]:=FormatFloat('0.00',TailleFichier(Strings[i]))
                               +' Ko';
        GridSource.Cells[3,NbImage]:=Strings[i];
        GridSource.RowCount:=GridSource.RowCount+1;
      end;
   end;
  if (GridSource.Cells[3,GridSource.row]<>'') and PreviewCheck.Checked then
    begin
      PreviewImage.Picture.LoadFromFile(GridSource.Cells[3,GridSource.row]);
      PreviewImage.show;
    end
end;

//Ajout le contenu d'un rpertoire
procedure TForm1.AjouterRprtoire1Click(Sender: TObject);
var  DossierChoisi:string;

begin

 if SelectDirectory('Slectionner un dossier','', DossierChoisi)then
   begin
      ScruteSource.Dossier:=DossierChoisi;
      ScruteSource.Filtre:='*.jpg';
      ScruteSource.execute;
   end;
 if (GridSource.Cells[3,GridSource.row]<>'') and PreviewCheck.Checked then
    begin
      PreviewImage.Picture.LoadFromFile(GridSource.Cells[3,GridSource.row]);
      PreviewImage.show;
    end
  else PreviewImage.Hide;
end;





//Changement de couleur de la bordure.
procedure TForm1.Shape1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ColorDialog1.Execute then
    Shape1.Brush.Color:=ColorDialog1.Color;
end;

//copie des images sources, gneration de la page html
//et cration des miniatures vers le dossier destination
procedure TForm1.Button1Click(Sender: TObject);
var i,j,nb:integer;
    result,body:TStringList;
    imgsrc,thumbsrc:string;
begin
  result:=TStringList.Create();
  body:=TStringList.Create();
  result.Add('<html>');
  result.Add('<result>');
  result.Add('<style type="text/css">');
  result.Add('<!--');
  result.Add('.pagetitle {');
  result.Add('  font-family: Verdana, Arial, Helvetica, sans-serif;');
  result.Add('  font-size: 24pt;');
  result.Add('  color: #000000;');
  result.Add('  font-weight: bold;');
  result.Add('}');
  result.Add('.thumbtitle {');
  result.Add('  font-family: Verdana, Arial, Helvetica, sans-serif;');
  result.Add('  font-size: 10pt;');
  result.Add('  color: #000000;');
  result.Add('}');
  result.Add('.imagetitle {');
  result.Add('  font-family: Verdana, Arial, Helvetica, sans-serif;');
  result.Add('  font-size: 10pt;');
  result.Add('  color: #000000;');
  result.Add('}');
  result.Add('.navigation {');
  result.Add('  font-family: Verdana, Arial, Helvetica, sans-serif;');
  result.Add('  font-size: 10pt;');
  result.Add('  color: #000000;');
  result.Add('  font-weight: bold;');
  result.Add('}');
  result.Add('-->');
  result.Add('</style>');
  result.Add('<title>'+edit6.Text+'</title>');
  result.add('</result><body bgcolor="#FFFFFF"><center><span class="pagetitle">'
                +edit6.Text+'</span><br><br>');
  result.Add('<table border="0" cellpadding="5" cellspacing="5">');


  ProgressBar1.Max:=NbImage*2;
  ProgressBar1.Position:=0;
  ProgressBar1.Step:=1;
  for i:=1 to NbImage do
    begin
       imgsrc:=ExtractFileName(GridSource.Cells[3,i]);
       //createThumb(srcFile,DestPath:String;size:integer;prefix:String;
       //shadow,border:boolean;bsize:integer;bcolor:TColor);
       createThumb(GridSource.Cells[3,i],edit4.Text,edit3.text,strtoint(edit1.text),
                   checkbox4.Checked,checkbox5.Checked,strtoint(edit5.text),
                   Shape1.Brush.Color);
       CopyFile(Pchar(GridSource.Cells[3,i]),Pchar(edit4.text+'\'
                              +ExtractFileName(GridSource.Cells[3,i])),false);
       thumbsrc:=ExtractFileName(edit3.text+imgsrc);
       ProgressBar1.StepIt;
       body.add('<td align="center"><a href="'+imgsrc+'"><img src="'+thumbsrc
                    +'"  border="0"></a></td>');
    end;
   i:=0;
   nb:= body.Count;
   while(i<=nb-4) do
    begin
        result.Add('<tr>');
        result.Add(body.Strings[i]);
        result.Add(body.Strings[i+1]);
        result.Add(body.Strings[i+2]);
        result.Add(body.Strings[i+3]);
        result.Add('</tr>');
        i:=i+4;
        ProgressBar1.StepIt;
    end;

   result.Add('<tr>');
   for j:=i to nb-1 do
    begin
        result.Add(body.Strings[j]);
        ProgressBar1.StepIt;
     end;
   result.Add('</tr>');
   result.Add('</body></html>');
   result.SaveToFile(edit4.text+'\index.htm');
  ProgressBar1.Position:=ProgressBar1.Max;
  ProgressBar1.Position:=0;

end;

//Controle sur les options de la bordure en cas de non slection
procedure TForm1.CheckBox5Click(Sender: TObject);
begin
    if CheckBox5.checked then
     begin
       label3.Enabled:=true;
       label4.Enabled:=true;
       edit5.Enabled:=true;
       Shape1.Enabled:=true;
       UpDown3.Enabled:=true;
     end
  else
    begin
       label3.Enabled:=false;
       label4.Enabled:=false;
       edit5.Enabled:=false;
       Shape1.Enabled:=false;
       UpDown3.Enabled:=false;
    end;
end;

//Choix du dossier de destionation 
procedure TForm1.Button2Click(Sender: TObject);
var  DossierChoisi:string;

begin

 if SelectDirectory('Slectionner un rpertoire','', DossierChoisi)then
     edit4.Text:=DossierChoisi;
end;

procedure TForm1.Edit3Exit(Sender: TObject);
begin
 if Edit3.Text='' then
   edit3.SetFocus
end;

end.



